﻿using System.ComponentModel;
using System.Windows.Forms;

namespace CustomTreeViewLabelEdit
{
  internal class NodeRequestTextEventArgs : CancelEventArgs
  {
    // Specifying custom text when using the LabelEdit functionality of a TreeView
    // http://cyotek.com/blog/specifying-custom-text-when-using-the-labeledit-functionality-of-a-treeview

    #region Constructors

    public NodeRequestTextEventArgs(TreeNode node, string label)
      : this()
    {
      this.Node = node;
      this.Label = label;
    }

    protected NodeRequestTextEventArgs()
    { }

    #endregion

    #region Properties

    public string Label { get; set; }

    public TreeNode Node { get; protected set; }

    #endregion
  }
}
